/*****************************************************************************************
* Character Type VFD App (Eng) Revision 1.02
*
* Description:
* Application can be used to load Character Type VFD library.
*
* Revision History:
*
* No   Date         Who    Function	    Description of Change
* ---------------------------------------------------------------------------------------
* 001  11/13/2009   KYH    PortOpen     To make user can select COM Port
*                                       Application loads enable COM ports from system regestry.
*										Application display COM ports in combo box.
*****************************************************************************************/
// VFD_APPDlg.cpp :  
//

#include "stdafx.h"
#include "VFD_APP.h"
#include "VFD_APPDlg.h"
#include ".\vfd_appdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CVFD_APPDlg ȭ 



CVFD_APPDlg::CVFD_APPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVFD_APPDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVFD_APPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);	
	DDX_Control(pDX, IDC_PORTCMB, m_Port);
}

BEGIN_MESSAGE_MAP(CVFD_APPDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
//	ON_BN_CLICKED(IDC_DLLCall, OnBnClickedDllcall)
	ON_BN_CLICKED(IDC_ClearText, OnBnClickedCleartext)
	ON_BN_CLICKED(IDC_DisplayText, OnBnClickedDisplaytext)
	ON_BN_CLICKED(IDC_SetDescriptor, OnBnClickedSetdescriptor)
	ON_BN_CLICKED(IDC_ClearDescriptors, OnBnClickedCleardescriptors)
	ON_BN_CLICKED(IDC_PortOpen, OnBnClickedPortopen)
	ON_BN_CLICKED(IDC_PORTCLOSE, OnBnClickedPortclose)
	ON_BN_CLICKED(IDC_DisplayTextAt, OnBnClickedDisplaytextat)
	ON_BN_CLICKED(IDC_OVERWRITEMODE, OnBnClickedOverwritemode)
	ON_BN_CLICKED(IDC_HORISCRLMODE, OnBnClickedHoriscrlmode)
	ON_BN_CLICKED(IDC_VERTISCRLMODE, OnBnClickedVertiscrlmode)
	ON_BN_CLICKED(IDC_SETCURON, OnBnClickedSetcuron)
	ON_BN_CLICKED(IDC_SETCUROFF, OnBnClickedSetcuroff)
	ON_BN_CLICKED(IDC_OFFDESCRIPTOR, OnBnClickedOffdescriptor)
	ON_BN_CLICKED(IDC_AddTextAt, OnBnClickedAddtextat)	
END_MESSAGE_MAP()


// CVFD_APPDlg ޽ ó

BOOL CVFD_APPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	// ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.

	//DLL load
	LoadDLL();

	//Load available serial ports from system registry
	SetSerialPort();
	
	return TRUE;  // Ʈѿ  Ŀ    TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸ 
// Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
// ӿũ  ۾ ڵ մϴ.

void CVFD_APPDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ. 
HCURSOR CVFD_APPDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVFD_APPDlg::OnBnClickedExit()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//	this->DestroyWindow();	
	OnBnClickedPortclose();
	FreeDLL();
	EndDialog(5);
}



void CVFD_APPDlg::LoadDLL(void)
{	
	hDll = LoadLibrary("VFD_DLL.dll");
	
	if (hDll == NULL)
	{		
		AfxMessageBox("Can't find DLL file.");
		return;
	}
}

void CVFD_APPDlg::FreeDLL(void)
{
	if (hDll != NULL)
	{
		FreeLibrary(hDll);
	}
}



void CVFD_APPDlg::OnBnClickedCleartext()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*clearTextFunc)();

		clearTextFunc lpclearTextFunc;

		lpclearTextFunc = (clearTextFunc)GetProcAddress(hDll,"clearText");

		lpclearTextFunc();
	}
}

//displayText
const LONG DISP_DT_NORMAL        = 0;
const LONG DISP_DT_BLINK         = 1;

//SetDescriptor
const LONG DISP_SD_OFF          = 0;
const LONG DISP_SD_ON           = 1;


void CVFD_APPDlg::OnBnClickedDisplaytext()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{

		typedef long (*displayTextFunc)(char* str);

		displayTextFunc lpdisplayTextFunc;

		lpdisplayTextFunc = (displayTextFunc)GetProcAddress(hDll,"displayText");

		CString str;
		GetDlgItemText(IDC_DISTEXT,str);

		if (str.GetLength() == 0)
		{
			AfxMessageBox("Input String!");
		}
		else
		{
			char* Temp = (char*)(const char*)str;
			lpdisplayTextFunc(Temp);
		}		

	}

}


void CVFD_APPDlg::OnBnClickedDisplaytextat()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{

		typedef long (*displayTextAtFunc)(long X , long Y, char str[]);

		displayTextAtFunc lpdisplayTextAtFunc;

		lpdisplayTextAtFunc = (displayTextAtFunc)GetProcAddress(hDll,"displayTextAt");
		

		CString numX;
		CString numY;
		CString str;
		GetDlgItemText(IDC_POSX,numX);
		GetDlgItemText(IDC_POSY,numY);
		GetDlgItemText(IDC_DISTEXTAT,str);

		if ((numX.GetLength() == 0) || (numY.GetLength() == 0) || (str.GetLength() == 0))
		{
			AfxMessageBox("Input coordinates and string!");
		}
		else
		{
			int Temp1 = _ttoi(numX);		
			int Temp2 = _ttoi(numY);		
			char* Temp3 = (char*)(const char*)str;

			lpdisplayTextAtFunc(Temp1, Temp2, Temp3);
		}		

	}


}

void CVFD_APPDlg::OnBnClickedAddtextat()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*AddTextAtFunc)(long X , long Y, char str[]);

		AddTextAtFunc lpAddTextAtFunc;

		lpAddTextAtFunc = (AddTextAtFunc)GetProcAddress(hDll,"AddTextAt");	

		CString numX;
		CString numY;
		CString str;
		GetDlgItemText(IDC_POSX2,numX);
		GetDlgItemText(IDC_POSY2,numY);
		GetDlgItemText(IDC_DISTEXTAT2,str);

		if ((numX.GetLength() == 0) || (numY.GetLength() == 0) || (str.GetLength() == 0))
		{
			AfxMessageBox("Input coordinates and string!");
		}
		else
		{
			int Temp1 = _ttoi(numX);		
			int Temp2 = _ttoi(numY);		
			char* Temp3 = (char*)(const char*)str;

			lpAddTextAtFunc(Temp1, Temp2, Temp3);
		}		

	}
}


void CVFD_APPDlg::OnBnClickedSetdescriptor()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{		
		typedef long (*SetDescriptorFunc)(long data,long attribute);

		SetDescriptorFunc lpSetDescriptorFunc;

		lpSetDescriptorFunc = (SetDescriptorFunc)GetProcAddress(hDll,"setDescriptor");
				
		
		CString num;	
		GetDlgItemText(IDC_DISPOS,num);

		if (num.GetLength() == 0)
		{
			AfxMessageBox("Input coordinates!");
		}
		else
		{
			int Temp1 = _ttoi(num);		

			lpSetDescriptorFunc(Temp1,DISP_SD_ON);
		}	

	}

}

void CVFD_APPDlg::OnBnClickedCleardescriptors()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{		
		typedef long (*ClsDescriptorFunc)();

		ClsDescriptorFunc lpClsDescriptorFunc;

		lpClsDescriptorFunc = (ClsDescriptorFunc)GetProcAddress(hDll,"clearDescriptors");

		lpClsDescriptorFunc();

		SetDlgItemText(IDC_DISPOS,"");
	}

}

void CVFD_APPDlg::OnBnClickedPortopen()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		CString PortName;

		GetDlgItemText(IDC_PORTCMB,PortName);

		typedef long (*PortOpenFunc)(CString str_PortName);

		PortOpenFunc lpPortOpenFunc;

		lpPortOpenFunc = (PortOpenFunc)GetProcAddress(hDll,"PortOpen");

		if (lpPortOpenFunc(PortName) == TRUE)
		{
			m_Port.EnableWindow(FALSE);
		}
	}

}

void CVFD_APPDlg::OnBnClickedPortclose()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*PortCloseFunc)();

		PortCloseFunc lpPortCloseFunc;

		lpPortCloseFunc = (PortCloseFunc)GetProcAddress(hDll,"PortClose");

		if (lpPortCloseFunc() == TRUE)
		{
			m_Port.EnableWindow(TRUE);
		}
	}

}


void CVFD_APPDlg::OnBnClickedOverwritemode()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*OverwritemodeFunc)();

		OverwritemodeFunc lpOverwritemodeFunc;

		lpOverwritemodeFunc = (OverwritemodeFunc)GetProcAddress(hDll,"setOverwriteMode");

		lpOverwritemodeFunc();
	}
}

void CVFD_APPDlg::OnBnClickedHoriscrlmode()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*HoriscrlmodeFunc)();

		HoriscrlmodeFunc lpHoriscrlmodeFunc;

		lpHoriscrlmodeFunc = (HoriscrlmodeFunc)GetProcAddress(hDll,"setHoriScrlMode");

		lpHoriscrlmodeFunc();
	}
}

void CVFD_APPDlg::OnBnClickedVertiscrlmode()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*VertiscrlmodeFunc)();

		VertiscrlmodeFunc lpVertiscrlmodeFunc;

		lpVertiscrlmodeFunc = (VertiscrlmodeFunc)GetProcAddress(hDll,"setVertiScrlMode");

		lpVertiscrlmodeFunc();
	}
}

void CVFD_APPDlg::OnBnClickedSetcuron()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*SetcuronFunc)(long attribute);

		SetcuronFunc lpSetcuronFunc;

		lpSetcuronFunc = (SetcuronFunc)GetProcAddress(hDll,"setCursorOnOff");

		lpSetcuronFunc(1);

	}
}

void CVFD_APPDlg::OnBnClickedSetcuroff()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*SetcuroffFunc)(long attribute);

		SetcuroffFunc lpSetcuroffFunc;

		lpSetcuroffFunc = (SetcuroffFunc)GetProcAddress(hDll,"setCursorOnOff");

		lpSetcuroffFunc(0);
	}
}

void CVFD_APPDlg::OnBnClickedOffdescriptor()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (hDll != NULL)
	{
		typedef long (*SetDescriptorFunc)(long data,long attribute);

		SetDescriptorFunc lpSetDescriptorFunc;

		lpSetDescriptorFunc = (SetDescriptorFunc)GetProcAddress(hDll,"setDescriptor");
		
		CString num;	
		GetDlgItemText(IDC_DISPOS,num);

		if (num.GetLength() == 0)
		{
			AfxMessageBox("Input coordinates!");
		}
		else
		{
			int Temp1 = _ttoi(num);		

			lpSetDescriptorFunc(Temp1,DISP_SD_OFF);
		}		

	}
}

void CVFD_APPDlg::SetSerialPort()
{
	if (hDll != NULL)
	{
		m_Port.ResetContent();               //޺ڽ  ڿ 		

		if (!AddPortFromRegToCboBox(0,&m_Port))
		{			
			AfxMessageBox("Not available system port.");
		}
		else
		{
			m_Port.SetCurSel(0);
		}
	}
}


DWORD CVFD_APPDlg::AddPortFromRegToCboBox(BYTE ucType, CComboBox *pCbo)
{
	DWORD cnt = 0;
	CString BaseKey0(REG_SERIALPORT);
	HKEY tempKeyHnd;

	LONG Result, ret;   
	int  idx = 0;    
	TCHAR sVal[MAX_KEY_LENGTH];
	BYTE sData[MAX_VALUE_LENGTH];
	CString strtmp;
	memset(sVal, 0, MAX_KEY_LENGTH);
	memset(sData, 0, MAX_VALUE_LENGTH);

	DWORD dwValSize = MAX_KEY_LENGTH;
	DWORD dwDataSize = MAX_VALUE_LENGTH;

	//Port Open Test
	typedef long (*PortOpenFunc)(CString TempPort);				
	PortOpenFunc lpPortOpenFunc;
	lpPortOpenFunc = (PortOpenFunc)GetProcAddress(hDll,"PortOpen");

	//Port Close
	typedef long (*PortCloseFunc)();
	PortCloseFunc lpPortCloseFunc;
	lpPortCloseFunc = (PortCloseFunc)GetProcAddress(hDll,"PortClose");


	if(ucType == 0)
	{
		Result = ::RegOpenKeyEx(HKEY_LOCAL_MACHINE, BaseKey0, 0, KEY_READ, &tempKeyHnd);

		if(Result != ERROR_SUCCESS) 
		{
			//myLog.WriteLogFile("Registry open fail");
			TRACE("Registry open fail");
			return 0;
		}

		// Get Device Key.
		while(1)
		{
			dwValSize = MAX_KEY_LENGTH;
			dwDataSize = MAX_VALUE_LENGTH;
			sVal[0] = '\0';
			sData[0] = '\0';

			ret = RegEnumValue(
				tempKeyHnd,
				idx,
				sVal,
				&dwValSize,
				0,
				NULL,
				sData,
				&dwDataSize
				);

			if (ret == ERROR_SUCCESS)
			{
				strtmp.Format("%s",sData);

				//If system ports are in regestry, confirm port can be opened and display available ports in combo box. 
				if (lpPortOpenFunc(strtmp) == TRUE)
				{			
					pCbo->AddString(strtmp);					
					cnt++;

					lpPortCloseFunc();
				}
			}
			else
			{
				break;
			}

			idx++;		
		}
	}

	return cnt;

}




